/* ------------------------------------------------------ */
/*                        UNDOC.H                         */
/*           (c) 1990 Peter Plucinski & TOOLBOX           */
/* ------------------------------------------------------ */

/* ------------------------------------------------------ */
/* Funktion:  __VPTR; berechnet die Bildschirmadresse     */
/*            der angegebenen Koordinaten                 */
/* Aufruf  :  x,y = Bildschirmkoordinaten (Text)          */
/* Rckgabe:  Zeiger auf Bildschirmadresse                */
/* ------------------------------------------------------ */

extern void far * pascal __VPTR(int x, int y);


/* ------------------------------------------------------ */
/* Funktion:  __VALIDATEXY; prft, ob die angegebenen     */
/*            Koordinaten korrekt sind                    */
/* Aufruf  :  x1,y1,x2,y2 = Bildschirmkoordinaten eines   */
/*                          Rechtecks                     */
/* Rckgabe:  0 = Koordinaten sind nicht gltig           */
/*            1 = Koordinaten sind gltig                 */
/* ------------------------------------------------------ */

extern int pascal __VALIDATEXY(int x1,int y1,int x2,int y2);


/* ------------------------------------------------------ */
/* _video; Array mit wichtigen Bildschirmparametern       */
/*         (einige werden z.B. 'gettextinfo' zurckge-    */
/*         geben).                                        */
/*                                                        */
/*         [0]..[1]     linke obere Ecke des letzten      */
/*                      'window' Aufrufs (x-1, y-1)       */
/*         [2]..[3]     rechte untere Ecke des letzten    */
/*                      'window' Aufrufs (x-1, y-1)       */
/*         [2]	        max. absolute Spaltennr. - 1 im   */
/*                      aktuellen Fenster                 */
/*         [3]          max. absolute Zeilennr. - 1 im    */
/*                      aktuellen Fenster                 */
/*         [4]          Aktuelles Farbattribut            */
/*         [5]          Farbattribute beim Programmstart  */
/*         [6]          aktueller Bildschirmmodus         */
/*         [7]          max. Anzahl Zeilen                */
/*         [8]          max. Anzahl Spalten               */
/*         [9]          ?                                 */
/*         [10]         ?                                 */
/*         [11]..[14]   Anfangsadresse der Video-Karte    */
/* ------------------------------------------------------ */

extern char _video[];


/* ------------------------------------------------------ */
/* Funktion:  __CPUTN; gibt die ersten n Zeichen einer    */
/*            Zeichenkette aus                            */
/* Aufruf  :  s = Zeichenkette                            */
/*            n = Anzahl der auszugebenen Zeichen         */
/*            z1, z2 = (nicht benutzt, sollten 0 sein)    */
/* Rckgabe:  nichts                                      */
/* ------------------------------------------------------ */

extern void pascal __CPUTN(char far *s,int n,int z1,int z2);


/* ------------------------------------------------------ */
/* Funktion:  __VideoInt; fhrt einen INT 10h aus und     */
/*            sichert dabei auch das BP Register, das bei */
/*            manchem BIOS zerstrt wird.                 */
/* ------------------------------------------------------ */

extern void _VideoInt(void);


/* ------------------------------------------------------ */
/* Funktion:  _crtinit; schaltet auf einen neuen Bild-    */
/*            schirmmodus um und initialisiert alle       */
/*            internen Variablen.                         */
/* Aufruf  :  mode = Bildschirmmodus                      */
/* Rckgabe:  nichts                                      */
/* ------------------------------------------------------ */

extern void _crtinit(int mode);

/* ------------------------------------------------------ */
/*                   Ende von UNDOC.H                     */
